'------------------------------------------------------------------------------
'
'                           mrugadelko_v4.1
'                 Poprawki redukujce kod o 128 bajtw
'                              ko 89C2051
'
' Moe:
'  - mruga literami na matrycy led
'  - rolowac tekst na matrycach
'  - trzyma tekst do wyswietlenia w EEPROM
'  - odbiera tekst po RS232
'  - ma jakies bajery
'  - wersja 32*5
'------------------------------------------------------------------------------
$crystal = 22118400
$baud = 2400

Config Sda = P1.7
Config Scl = P1.6
Set Tcon.0
Config Timer0 = Timer , Mode = 1 , Gate = Internal

Enable Interrupts
Enable Timer0
Enable Int0

On Int0 Klawiatura
On Timer0 Skok Nosave

Declare Sub Odczyt
Declare Sub Zapis
Declare Sub Obsluga_timera

Dim Timerint As Bit
Dim Flaga As Bit
Dim Flagazap As Bit
Dim Bajer As Bit
Dim X As Byte
Dim Poz As Byte
Dim Full As Byte
Dim Nznaku As Byte
Dim Rov(32) As Byte
Dim Pom1 As Byte
Dim Speed As Byte
Dim Bajerpom As Byte
Dim Repeat As Byte
Dim Znak As String * 1

'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
Dim Idx As Byte , Idx2 As Byte
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

'---------------------
Speed = 100
Poz = 1
X = 92
'Repeat = 0
'Bajer = 0
'Bajerpom = 0
Flaga = 1
'Flagazap = 0
'Nznaku = 0
Call Odczyt
Full = Pom1
Nznaku = 1
Start Timer0

Do

   If Flaga = 1 Then
      Stop Timer0
      Call Odczyt
      Restore Nic
      Select Case Pom1
         Case 97 : Restore A
         Case 98 : Restore Bb
         Case 99 : Restore C
         Case 100 : Restore D
         Case 101 : Restore Litera_e
         Case 102 : Restore F
         Case 103 : Restore G
         Case 104 : Restore H
         Case 105 : Restore I
         Case 106 : Restore J
         Case 107 : Restore K
         Case 108 : Restore L
         Case 109 : Restore M
         Case 110 : Restore N
         Case 111 : Restore O
         Case 112 : Restore P
         Case 114 : Restore R
         Case 115 : Restore S
         Case 116 : Restore T
         Case 117 : Restore U
         Case 119 : Restore W
         Case 121 : Restore Y
         Case 122 : Restore Z
         Case 76 : Restore 
         Case 32 : Restore Nic
         Case 33 : Restore Wykrzyk
         Case 48 : Restore Zero
         Case 49 : Restore Jeden
         Case 50 : Restore Dwa
         Case 51 : Restore Trzy
         Case 52 : Restore Cztery
         Case 53 : Restore S
         Case 54 : Restore Szesc
         Case 55 : Restore Siedem
         Case 56 : Restore Osiem
         Case 57 : Restore Dziewiec
         Case 62 : Bajer = 1
         Case 60 : Bajer = 0
         Case 43 : Decr Speed
         Case 45 : Incr Speed
      End Select
      Flaga = 0
      Start Timer0
   End If

   If Flagazap = 1 Then
      Stop Timer0
      P1 = 255
      Print " Tryb edycji"
      Full = 0
      Do
         Znak = Inkey
         Pom1 = Asc(znak)
         If Pom1 > 0 Then
            Incr Full
            Print Znak
            Call Zapis
            If Pom1 = 27 Then
               Print "end"
               Exit Do
            End If
         End If
      Loop
      Flagazap = 0
      Pom1 = Full
      Full = 0
      Call Zapis
      Start Timer0
   End If

   If Timerint = 1 Then
      Call Obsluga_timera
      Timerint = 0
   End If

Loop

End

'--------------------------------------------
'------------ dane obrazy znakw ------------
'--------------------------------------------
A:
 Data 223 , 208 , 205 , 208
Bb:
 Data 223 , 192 , 202 , 213
C:
 Data 223 , 209 , 206 , 206
D:
 Data 223 , 192 , 206 , 209
Litera_e:
 Data 223 , 192 , 202 , 206
F:
 Data 223 , 192 , 203 , 207
G:
 Data 223 , 209 , 202 , 201
H:
 Data 223 , 192 , 219 , 192
I:
 Data 223 , 223 , 192 , 223
J:
 Data 223 , 204 , 206 , 192
K:
 Data 223 , 192 , 213 , 206
L:
 Data 223 , 192 , 222 , 222
:
 Data 223 , 192 , 218 , 222
M:
 Data 223 , 192 , 215 , 192
N:
 Data 223 , 192 , 211 , 192
O:
 Data 223 , 209 , 206 , 209
P:
 Data 223 , 192 , 203 , 195
R:
 Data 223 , 192 , 201 , 194
S:
 Data 223 , 194 , 202 , 200
T:
 Data 223 , 207 , 192 , 207
U:
 Data 223 , 192 , 222 , 192
W:
 Data 223 , 192 , 217 , 192
Y:
 Data 223 , 199 , 216 , 199
Z:
 Data 223 , 204 , 202 , 198
Nic:
 Data 223 , 223 , 223 , 223
Wykrzyk:
 Data 223 , 194 , 194 , 223
Zero:
 Data 223 , 192 , 206 , 192
Jeden:
 Data 223 , 223 , 215 , 192
Dwa:
 Data 223 , 214 , 204 , 210
Trzy:
 Data 223 , 206 , 202 , 192
Cztery:
 Data 223 , 195 , 219 , 208
Szesc:
 Data 223 , 209 , 202 , 205
Siedem:
 Data 223 , 204 , 203 , 199
Osiem:
 Data 223 , 192 , 202 , 192
Dziewiec:
 Data 223 , 194 , 202 , 193


'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'dodabym do lini DATA jeszcze dwie (potrzebne w podprogramie Skok):
Port3:
  Data 0 , 63 , 183 , 55 , 191 , 143 , 7 , 15 , 135
  Data 39 , 175 , 47 , 167 , 159 , 31 , 151 , 23
  Data 63 , 183 , 55 , 191 , 143 , 7 , 15 , 135
  Data 39 , 175 , 47 , 167 , 159 , 31 , 151 , 23
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

'--------------------------------------------
'------------ przerwanie TIMER --------------
'--------------------------------------------
Skok:
  Counter0 = 64600              '40 Hz per wyswietlacz; 50Hz 64400
  Start Timer0
  Timerint = 1

Return

Sub Obsluga_timera

  Incr Poz

'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
   'cig klikunastu If..Then mona przecie uproci:
   P1 = 255
   P3 = Lookup(poz , Port3)

   If Poz > 16 Then
      P1 = Rov(poz)
      P1.5 = 1
   Else
      P1.5 = 0
      P1 = Rov(poz)
   End If

   If Poz = 32 Then
     Incr X
     Poz = 0
   End If
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

  If X = Speed Then

'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
    'po co si tyle rozpisywa przecie wystarczy:
    For Idx = 32 Downto 1
      Idx2 = Idx - 1
      Rov(idx) = Rov(idx2)
    Next Idx
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

    Read Rov(1)
    Incr Repeat
    If Bajer = 0 Then
      X = 92
    End If
    If Bajer = 1 Then
      If Bajerpom > 31 And Rov(32) <> 223 Then
        X = 0
        Bajerpom = 0
      Else
        X = Speed - 2
        Incr Bajerpom
      End If
    End If
  End If
  If Repeat = 4 Then
    Repeat = 0
    Flaga = 1
    Incr Nznaku
    If Nznaku = Full Then
      Nznaku = 1
      Speed = 100
      Bajer = 0
    End If
  End If

End Sub

'--------------------------------------------
'------------ przerwanie INT0 ---------------
'--------------------------------------------
Klawiatura:
  If P3.4 = 0 Then
    Flagazap = 1
  End If
Return


'--------------------------------------------
'------------ EEPROM ------------------------
'--------------------------------------------
Sub Odczyt
  I2cstart
  I2cwbyte 160
  I2cwbyte Nznaku
  I2cstart
  I2cwbyte 161
  I2crbyte Pom1 , Nack
  I2cstop
End Sub


Sub Zapis
  I2cstart
  I2cwbyte 160
  I2cwbyte Full
  I2cwbyte Pom1
  I2cstop
  Waitms 10
End Sub